<?php

namespace RxConnexionBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="RxConnexionBundle\Repository\MaterialRequisitionStatusRepository")
 * @ORM\Table(name="material_requisition_status")
 * @ORM\HasLifecycleCallbacks()
 */

class MaterialRequisitionStatusEntity
{
    /**
     * @ORM\Column(type="bigint")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @ORM\Column(name="status", type="string", nullable=true)
     */
    protected $status;

    /**
     * @ORM\Column(name="approval_description", type="string", nullable=true)
     */
    protected $approvalDescription;

    /**
     * @ORM\Column(name="note", type="text", nullable=true)
     */
    protected $note;

    /**
     * @ORM\Column(name="batch_no", type="integer")
     */
    protected $batchNo;

    /**
     * @ORM\Column(name="created_by", type="string", length=50)
     */
    protected $createdBy;

    /**
     * @ORM\Column(name="created_at", type="datetime")
     */
    protected $createdAt;

    /**
     * @ORM\Column(name="updated_by", type="string", length=50)
     */
    protected $updatedBy;

    /**
     * @ORM\Column(name="updated_at", type="datetime")
     */
    protected $updatedAt;

    /**
     * @ORM\ManyToOne(targetEntity="MaterialRequisitionEntity", inversedBy="materialRequisitionStatuses")
     * @ORM\JoinColumn(name="material_requisition_id", referencedColumnName="id")
     */
    protected $materialRequisition;

    /**
     * @ORM\ManyToOne(targetEntity="RxConnexionBundle\Entity\AccountUserEntity", inversedBy="materialRequisitionStatuses")
     * @ORM\JoinColumn(name="account_user_id", referencedColumnName="id")
     */
    protected $accountUser;

    /**
     * Set createdAt
     *
     * @ORM\PrePersist
     */
    public function setCreatedAtValue()
    {
        $this->createdBy = isSet($_COOKIE['username']) ? $_COOKIE['username'] : 'System';
        $this->createdAt = new \DateTime();
        $this->updatedBy = isSet($_COOKIE['username']) ? $_COOKIE['username'] : 'System';
        $this->updatedAt = new \DateTime();
        $this->setApprovalDescription('Pending');
    }

    /**
     * Set updatedAt
     *
     * @ORM\PreUpdate
     */
    public function setUpdatedAtValue()
    {
        $this->updatedBy = $_COOKIE['username'];
        $this->updatedAt = new \DateTime();
    }

    public function __construct($data=null)
    {
        if(!is_null($data)) {
            $this->id = $data->getId();
            $this->status = $data->getStatus();
            $this->approvalDescription = $data->getApprovalDescription();
            $this->note = $data->getNote();
            $this->batchNo = $data->getBatchNo();
            $this->materialRequisition = $data->getMaterialRequisition();
            $this->accountUser = $data->getAccountUser();
        }
    }

    /*--------------------------------------------------------------------------------------------------------*/
    /*					User Defined Setters and Getters													  */
    /*--------------------------------------------------------------------------------------------------------*/

    /*--------------------------------------------------------------------------------------------------------*/
    /*					Setters and Getters																	  */
    /*--------------------------------------------------------------------------------------------------------*/

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set status
     *
     * @param string $status
     * @return MaterialRequisitionStatusEntity
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * Get status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Set approvalDescription
     *
     * @param string $approvalDescription
     * @return MaterialRequisitionStatusEntity
     */
    public function setApprovalDescription($approvalDescription)
    {
        $this->approvalDescription = $approvalDescription;

        return $this;
    }

    /**
     * Get approvalDescription
     *
     * @return string
     */
    public function getApprovalDescription()
    {
        return $this->approvalDescription;
    }

    /**
     * Set note
     *
     * @param string $note
     * @return MaterialRequisitionStatusEntity
     */
    public function setNote($note)
    {
        $this->note = $note;

        return $this;
    }

    /**
     * Get note
     *
     * @return string
     */
    public function getNote()
    {
        return $this->note;
    }

    /**
     * Set batchNo
     *
     * @param integer $batchNo
     * @return MaterialRequisitionStatusEntity
     */
    public function setBatchNo($batchNo)
    {
        $this->batchNo = str_replace(',', '', $batchNo);

        return $this;
    }

    /**
     * Get batchNo
     *
     * @return integer
     */
    public function getBatchNo()
    {
        return $this->batchNo;
    }

    /**
     * Set createdBy
     *
     * @param string $createdBy
     * @return MaterialRequisitionStatusEntity
     */
    public function setCreatedBy($createdBy)
    {
        $this->createdBy = $createdBy;

        return $this;
    }

    /**
     * Get createdBy
     *
     * @return string
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set createdAt
     *
     * @param \DateTime $createdAt
     * @return MaterialRequisitionStatusEntity
     */
    public function setCreatedAt($createdAt)
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    /**
     * Get createdAt
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * Set updatedBy
     *
     * @param string $updatedBy
     * @return MaterialRequisitionStatusEntity
     */
    public function setUpdatedBy($updatedBy)
    {
        $this->updatedBy = $updatedBy;

        return $this;
    }

    /**
     * Get updatedBy
     *
     * @return string
     */
    public function getUpdatedBy()
    {
        return $this->updatedBy;
    }

    /**
     * Set updatedAt
     *
     * @param \DateTime $updatedAt
     * @return MaterialRequisitionStatusEntity
     */
    public function setUpdatedAt($updatedAt)
    {
        $this->updatedAt = $updatedAt;

        return $this;
    }

    /**
     * Get updatedAt
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->updatedAt;
    }

    /**
     * Set materialRequisition
     *
     * @param \RxConnexionBundle\Entity\MaterialRequisitionEntity $materialRequisition
     * @return MaterialRequisitionStatusEntity
     */
    public function setMaterialRequisition(\RxConnexionBundle\Entity\MaterialRequisitionEntity $materialRequisition = null)
    {
        $this->materialRequisition = $materialRequisition;

        return $this;
    }

    /**
     * Get materialRequisition
     *
     * @return \RxConnexionBundle\Entity\MaterialRequisitionEntity
     */
    public function getMaterialRequisition()
    {
        return $this->materialRequisition;
    }

    /**
     * Set User
     *
     * @param \RxConnexionBundle\Entity\UserEntity $user
     * @return MaterialRequisitionStatusEntity
     */
    public function setUser(\RxConnexionBundle\Entity\UserEntity $user = null)
    {
        $this->user = $user;

        return $this;
    }

    /**
     * Get User
     *
     * @return \RxConnexionBundle\Entity\UserEntity
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * Set accountUser
     *
     * @param \RxConnexionBundle\Entity\AccountUserEntity $accountUser
     *
     * @return MaterialRequisitionStatusEntity
     */
    public function setAccountUser(\RxConnexionBundle\Entity\AccountUserEntity $accountUser = null)
    {
        $this->accountUser = $accountUser;

        return $this;
    }

    /**
     * Get accountUser
     *
     * @return \RxConnexionBundle\Entity\AccountUserEntity
     */
    public function getAccountUser()
    {
        return $this->accountUser;
    }
}
